﻿using System;
using System.Collections.Generic;
using System.Text;
using WindowsLive.Writer.Api;
using System.Windows.Forms;

namespace WlOdeko
{
    /// <summary>
    /// ContentSource を継承してWLWの挿入プラグインとします。
    /// プラグインの情報をクラスの属性として与えます。
    /// </summary>
    [WriterPlugin(
        "25e0a22d-24fe-409c-b23e-d8fa4151ec9a",
        "WlOdeko",
        Description = "おでこを挿入します。",
        HasEditableOptions = false,
        Name = "WlOdeko",
        PublisherUrl = "http://another.maple4ever.net",
        ImagePath = "icon.png")]
    [InsertableContentSource("おでこ")]
    public class WlOdeko : ContentSource
    {
        /// <summary>
        /// WLW 挿入系プラグインのメソッドオーバーライド
        /// </summary>
        /// <param name="dialogOwner">WLWの親フォーム</param>
        /// <param name="content">挿入文字列の参照</param>
        /// <returns>ダイアログレザルト</returns>
        public override DialogResult CreateContent
           (IWin32Window dialogOwner, ref string content)
        {
            using (WlOdekoForm form = new WlOdekoForm())
            {
                DialogResult result = form.ShowDialog(dialogOwner);
                if (result == DialogResult.OK)
                {
                    content = form.dialogResult;
                }
                return result;
            }
        }
    }
}
