﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Xml;
using System.Data;
using System.Drawing;
using System.Text;
using System.Security.Cryptography;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace WlOdeko
{
    public partial class WlOdekoForm : Form
    {
        //結果HTML格納（いじらない）
        private String resultHTML = "";

        //WLW値取得用プロパティ設定（いじらない）
        public String dialogResult
        {
            set { this.resultHTML = value; }
            get { return resultHTML; }
        }

        /// <summary>
        /// Visual Stdio が自動生成したコンストラクタ（いじらない）
        /// </summary>
        public WlOdekoForm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// OKボタン押下時の処理（ここでがんばる）
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            //テキストボックスの値配列まわしてひとつの文字列にとりあえず連結。
            String htmlString = "";
            foreach (String line in this.textBox1.Lines)
            {
                htmlString += line;
            }

            //正規表現でがんばって文字列にした HTML から必要な属性を取得
            String flickrURL = "";
            String flickrCaption = "";
            String imgSrcBig = "";
            String imgSrcNormal = "";
            String hashString = "";

            //a タグ属性取得
            Regex regAtag =
                new Regex("<a href=\"(?<1>.*)\" title=\"(?<2>.*) by .*, on Flickr\">");
            Match matchAtag = regAtag.Match(htmlString);
            if (matchAtag.Success)
            {
                flickrURL = matchAtag.Groups[1].Value;
                flickrCaption = matchAtag.Groups[2].Value;
            }
            //img タグ属性取得
            Regex regImgtag =
                new Regex("<img src=\"(?<1>.*)\" width=\"");
            Match matchImgtag = regImgtag.Match(htmlString);
            if (matchImgtag.Success)
            {
                imgSrcBig = matchImgtag.Groups[1].Value;
                if (imgSrcBig.Length >= 6)
                {
                    imgSrcNormal = imgSrcBig.Remove(imgSrcBig.Length - 6) + ".jpg";
                }
            }

            //バリデーション（どれかとれてなかったら不正ってことで）
            if (flickrURL.Length == 0 || flickrCaption.Length == 0 ||
                imgSrcBig.Length == 0 || imgSrcNormal.Length == 0)
            {
                //エラーダイアログ表示
                MessageBox.Show(
                    "HTMLの解析に失敗しました。", 
                    "おでこの挿入",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                //入力ダイアログ閉じないで入力継続
                this.DialogResult = DialogResult.None;
                return;
            }

            //Flickr の URL から highslide 用ハッシュ作成
            byte[] hashByte = System.Text.Encoding.ASCII.GetBytes(imgSrcBig);
            MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider();
            byte[] bs = md5.ComputeHash(hashByte);
            hashString = BitConverter.ToString(bs).ToLower().Replace("-", "");

            //出力HTML作成
            String resultHtml;
            //たせたせ団。段落部分。
            resultHtml = "<p>";
            resultHtml += "<a class=\"highslide\" onclick=\"return hs.expand(this)\" href=\"";
            resultHtml += imgSrcBig + "\">";
            resultHtml += "<img id=\"thumb" + hashString + "\"" + "title=\"Click to enlarge\" ";
            resultHtml += "alt=\"" + flickrCaption + "\" ";
            resultHtml += "src=\"" + imgSrcNormal + "\" ";
            resultHtml += " width=\"500\" height=\"334\" />";
            resultHtml += "</a></p>";
            //たせたせ団。div 部分。
            resultHtml +=
                "<div class=\"highslide-caption\" id=\"caption-for-thumb"+ hashString + "\">";
            resultHtml +=
                "<a title=\"go 2 flickr\" href=\"" + flickrURL + "\" target=\"_blank\">";
            resultHtml += flickrCaption + "</a>";
            resultHtml += "</div>";
            resultHtml += "<p></p>";

            //結果をプロパティに格納
            dialogResult = resultHtml;
            //ダイアログ正常終了
            this.DialogResult = DialogResult.OK;
        }
    }
}
